	;; extern C function
	.globl	___main

	;; 
	.globl	_init_interrupts
	.globl	_vsync
	.globl	_init_sound_driver

	.globl	_init_module
	.globl	_play_module

	.globl	_vblQueue
	;;

	.text	
	.globl	_main

BASE		EQU	$F00000	; TOM Internal Register Base
VMODE		EQU	BASE+$28	; Video Mode
BG		EQU	BASE+$58	; Background Color

RGB16		EQU	$0006		; Enable 16-bit RGB mode
CSYNC		EQU	$0040		; Enable composite sync
BGEN		EQU	$0080		; Clear line buffer to BG
PWIDTH4		EQU	$0600		; Select pixels 4 clocks wide
VIDEN		EQU	$0001		; Enable video-time base generator

RED	equ	$f800
BLUE	equ	$07c0
GREEN	equ	$003f
	
	.68000
_main:
	;; finish init (random seed, malloc, ...)
	jsr	___main
	;;
	move.w	#RGB16|CSYNC|BGEN|PWIDTH4|VIDEN,VMODE
	;; init interrupts (VBL queue)
	jsr	_init_interrupts
	;; init sound driver
	move.l	#45000,-(sp)	; 45 kHz
	jsr	_init_sound_driver
	addq.w	#4,sp
	move.l	d0,realfreq
	;;
	move.l	#0,-(sp)	; disable tempo commands
	move.l	#muzak,-(sp)	; load mod address
	jsr	_init_module
	addq.w	#8,sp
	;;
	move.l	#vbl_handler,_vblQueue
.loop:
	jsr	_vsync
	bra.s	.loop

vbl_handler:
	move.w	#BLUE,BG
	jsr	_play_module
	move.w	#0,BG
	rts

	.bss
realfreq:	ds.l	1

	.data
	
	.even
muzak:
	incbin	"subgliep.mod"
	.rept	31
	dc.w	0
	.endr


	
